//---------------------------------
// Procedures pour la gestion du DAC
//---------------------------------



//------------------------------------------------------
// Fonction ecriture dans le DAC
// Le paramètre est la donnée 16 bits du registre du DAC
//------------------------------------------------------
void writeDAC(uint16_t datain) {
   	// Ecriture rapide dans SPI
	//-------------------------
	PORTB &= ~(1<<1);						// Chip select (pin 9 = PORTB bit 1)
    SPDR = highByte(datain) | 0x70;			// Copie MSB + 4 bits programmation du DAC (buffered, 1x gain et active mode)
    while (!(SPSR & (1<<SPIF)));			// Attente de la copie
    SPDR = lowByte(datain);					// Copie du LSB
    while (!(SPSR & (1<<SPIF)));			// Attente de la copie
    PORTB |= (1<<1);						// Liberation du chip (pin 9 = PORTB bit 1)
	
}
