//--------------------------------
// Gestion des menus
// lecture des boutons
// bascule des fonction sur la x0x
// gestion allumage des leds
//--------------------------------


//-------------------------------------------
// Lit les boutons et renvoie la valeurs lues
// Ne permet qu'une saisie quand un bouton
// est appuyé
//-------------------------------------------
int readButtons(int pin) {
int b,c = 0;
  c=analogRead(pin);      // Lit lentree analogique 
    if (c>1000) {
      lastbouton=0;  // Remettre flag etat a zero
      return 0;           // Pas de bouton appuyé sortir
  }
  // Arrive ici normalement un bouton a ete appuye
  for (int i=1; i<DEBOUNCE; i++) {
    MIDI.read();
    delay(1);              // Attente
  }
  
  c=analogRead(pin);      // Relire pour debouncing 
  
  if (lastbouton>0)   // Si le dernier bouton n'a pas ete relache
      return 9;   // renvoit code+10 (touche 1 = 11, 2=12, etc)
  // Arrivé ici on est sur que le bouton a ete appuye
  if (c>50 && c<150) {
      lastbouton=6;
      return 6;           // bouton 1 appuye
  } 
  if (c>230 && c<320) {
      lastbouton=5;
      return 5;           // bouton 1 appuye
  } 
  if (c>350 && c<450) {
      lastbouton=4;
      return 4;           // bouton 1 appuye
  } 
  if (c>500 && c<600) {
      lastbouton=3;
      return 3;           // bouton 1 appuye
  } 
  if (c>650 && c<750) {
      lastbouton=2;
      return 2;           // bouton 1 appuye
  } 
  if (c>800 && c<900) {
      lastbouton=1;
      return 1;           // bouton 1 appuye
  } 
}

//----------------------------------
// rafraichissement etat oscillateur
//----------------------------------
void refresh_wave(void)
{
	switch(v_wave) {
		// Only square
		case 1:
			PORTD |= (1<<2);	// pin D2 niveau HIGH, LED SQUARE ON
			PORTD &= ~(1<<3);	// pin D3 niveau LOW, LED SAW OFF
			break;
		// Only saw
		case 2:
			PORTD &= ~(1<<2);	// pin D2 niveau LOW, LED SQUARE OFF
			PORTD |= (1<<3);	// pin D3 niveau HIGH, LED SAW ON
			break;
		// square + saw
		case 3:
			PORTD |= (1<<2);	// pin D2 niveau HIGH, LED SQUARE ON
			PORTD |= (1<<3);	// pin D3 niveau HIGH, LED SAW ON
			break;
	}
}

//----------------------------
// rafraichissement etat slide
//----------------------------
void refresh_slide(void)
{
	switch(v_slide) {
		// no slide
		case 0:
			PORTD &= ~(1<<4);	// pin D4 niveau LOW, LED <- OFF
			PORTD &= ~(1<<5);	// pin D5 niveau LOW, LED -> OFF
			break;
		// slide input
		case 1:
			PORTD |= (1<<4);	// pin D4 niveau HIGH, LED <- ON
			PORTD &= ~(1<<5);	// pin D5 niveau LOW, LED -> OFF
			break;
		// slide output
		case 2:
			PORTD &= ~(1<<4);	// pin D4 niveau LOW, LED <- OFF
			PORTD |= (1<<5);	// pin D5 niveau HIGH, LED -> ON
			break;
	}
}

//-----------------------------
// rafraichissement etat cutoff
//-----------------------------
void refresh_cutoff(void)
{
	if (v_cutoff)
		PORTD |= (1<<6);	// pin D6 niveau HIGH, LED CUTOFF ON
	else
		PORTD &= ~(1<<6);	// pin D6 niveau LOW, LED CUTOFF OFF
}

//----------------------------
// rafraichissement etat decay
//----------------------------
void refresh_decay(void)
{
	if (v_decay)
		PORTD |= (1<<7);	// pin D7 niveau HIGH, LED DECAY ON
	else
		PORTD &= ~(1<<7);	// pin D7 niveau LOW, LED DECAY OFF
}

//-----------------------------
// rafraichissement etat accent
//-----------------------------
void refresh_accent(void)
{
	if (v_accent)
		PORTC |= (1<<1);	// pin A1 niveau HIGH, LED ACCENT ON
	else
		PORTC &= ~(1<<1);	// pin A1 niveau LOW, LED ACCENT OFF
}

//-----------------------------
// rafraichissement etat envmod
//-----------------------------
void refresh_envmod(void)
{
	if (v_envmod)
		PORTC |= (1<<2);	// pin A2 niveau HIGH, LED ENVMOD ON
	else
		PORTC &= ~(1<<2);	// pin A2 niveau LOW, LED ENVMOD OFF
}


//--------------------------------------------
// Lecture des interrupteurs de la facade
// pour basculer les fonctions de la carte x0x
//--------------------------------------------
void gestionBoutons(void)
{
	// Lire la valeur du bouton
    valbouton=readButtons(BNAV);
    if (valbouton==0)     // Si aucun bouton appuye on sort
        return;           // pour ne pas perdre de temps
    switch(valbouton) {
		// Bouton maintenu appuye
        case B_MAINT:
            break;
		// Changement oscillateur
		// (1:square, 2:saw, 3:square+saw)
		case B_WAVE:
			if (v_wave==3)
				v_wave=1;
			else 
				v_wave++;
			refresh_wave();
			break;
		// Changement du slide
		// (0: sans, 1: input, 2: output)
		case B_SLIDE:
			if (v_slide==2)
				v_slide=0;
			else
				v_slide++;
			refresh_slide();
			break;
			
		// Changement decay
		// (0: inactif, 1: actif)
		case B_DECAY:
			if (v_decay)
				v_decay=0;
			else
				v_decay=1;
			refresh_decay();
			break;

			// Changement de laccent
		// (0: inactif, 1: actif)
		case B_ACCENT:
			if (v_accent)
				v_accent=0;
			else
				v_accent=1;
			refresh_accent();
			break;

			// Changement de laccent
		// (0: inactif, 1: actif)
		case B_CUTOFF:
			if (v_cutoff)
				v_cutoff=0;
			else
				v_cutoff=1;
			refresh_cutoff();
			break;
		// Changement de l'envmod
		// (0: inactif, 1: actif)
		case B_ENVMOD:
			if (v_envmod)
				v_envmod=0;
			else
				v_envmod=1;
			refresh_envmod();
			break;
    }
}
